Attribute VB_Name = "psuomo_var"
' NoteRepeat used to stop the same key from repeating.  CapsLock detects if it is down.
Global NoteRepeat As Integer

Global Const MODAL = 1

' The Patch number array used for current patch for each midi channel
' Then Volume array used for each channels volume setting
' TrackChannel is array for the current midi channel that that Track on the mixi is set to.
Global MidiPatch(TOTAL_MIDI_CHANNELS) As Integer
Global MidiVolume(TOTAL_MIDI_CHANNELS) As Integer
Global TrackChannel(TOTAL_MIDI_CHANNELS) As Integer
Global MidiPan(TOTAL_MIDI_CHANNELS) As Integer
Global Octave(TOTAL_MIDI_CHANNELS) As Integer

' The current Midi Channel out set on Piano form
Global MidiChannelOut As Integer

' The Velocity (Volume) of notes for current midi channel
Global MidiVelocity As Integer

' The Mouse Music Stuff:
Global MyX As Integer ' the coordinates
Global MyY As Integer

Global PerfIndex As Integer 'the performance area used

'
' 0 Pitch
' 1 Velocity
' 2 Pan
' 3 Channel
' 4 Volume
'
Global PerfHeightMode(3) As Integer
Global PerfWidthMode(3) As Integer
Global PerfMode(3) As Integer

Public Sub MouseMode5()
 ' pitch/programme
    frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    frmMain.MIDIOutput1.Data2 = frmMain.VelText(PerfIndex).Text
    frmMain.MIDIOutput1.Data1 = -(MyY - 128)
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    'pan:
    frmMain.MIDIOutput1.Message = PROGRAM_CHANGE + MidiChannelOut
    frmMain.MIDIOutput1.Data1 = MyX
    frmMain.MIDIOutput1.Data2 = 0
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Pitch " & -(MyY - 128) & ", " & "Prog " & MyX
End Sub

Public Sub MouseMode10()
 'vel/pitch
    frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    frmMain.MIDIOutput1.Data2 = MyY
    frmMain.MIDIOutput1.Data1 = MyX
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Vel " & MyY & ", " & "Pitch " & MyX
End Sub

Public Sub MouseMode14()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub

Public Sub MouseMode15()
 ' vel/programme
    frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    frmMain.MIDIOutput1.Data2 = -(MyY - 128)
    frmMain.MIDIOutput1.Data1 = frmMain(PerfIndex).PitchText.Text
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    'pan:
    frmMain.MIDIOutput1.Message = PROGRAM_CHANGE + MidiChannelOut
    frmMain.MIDIOutput1.Data1 = MyX
    frmMain.MIDIOutput1.Data2 = 0
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Vel " & -(MyY - 128) & ", " & "Prog " & MyX
End Sub

Public Sub MouseMode20()
 ' pan/pitch
    frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    frmMain.MIDIOutput1.Data2 = frmMain.VelText(PerfIndex).Text
    frmMain.MIDIOutput1.Data1 = MyX
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    'pitch:
    frmMain.MIDIOutput1.Message = CONTROLLER_CHANGE + MidiChannelOut
    frmMain.MIDIOutput1.Data1 = PAN
    frmMain.MIDIOutput1.Data2 = -(MyY - 128)
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Pan " & -(MyY - 128) & ", " & "Pitch " & MyX
End Sub

Public Sub MouseMode21()
 ' pan/velocity
 'pan (H):
    frmMain.MIDIOutput1.Message = CONTROLLER_CHANGE + MidiChannelOut
    frmMain.MIDIOutput1.Data1 = PAN
    frmMain.MIDIOutput1.Data2 = MyX
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
 'vel (W):
    frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    frmMain.MIDIOutput1.Data2 = -(MyY - 128)
    frmMain.MIDIOutput1.Data1 = frmMain.PitchText(PerfIndex).Text
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Pan " & -(MyY - 128) & ", " & "Vel " & MyX
End Sub

Public Sub MouseMode22()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub

Public Sub MouseMode23()
'H:pan; W:channel
 'pan (V):
    frmMain.MIDIOutput1.Message = CONTROLLER_CHANGE + MidiChannelOut
    frmMain.MIDIOutput1.Data1 = PAN
    frmMain.MIDIOutput1.Data2 = MyX
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
 'channel (H):
    MidiChannelOut = Int(MyY / 8) 'half the usual amount for channels
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Pan " & MyX & ", " & "Chn " & Int(MyY / 2)

End Sub

Public Sub MouseMode24()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub

Public Sub MouseMode25()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub

Public Sub MouseMode30()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub

Public Sub MouseMode31()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub

Public Sub MouseMode32()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub

Public Sub MouseMode34()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub

Public Sub MouseMode33()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub

Public Sub MouseMode35()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub

Public Sub MouseMode11()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
Public Sub MouseMode40()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub

Public Sub MouseMode13()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
Public Sub MouseMode41()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
Public Sub MouseMode42()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
Public Sub MouseMode43()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
Public Sub MouseMode44()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
Public Sub MouseMode45()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
Public Sub MouseMode12()
 ' velocity/pan
    frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    frmMain.MIDIOutput1.Data2 = -(MyY - 128)
    frmMain.MIDIOutput1.Data1 = frmMain.PitchText(PerfIndex).Text
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    'pan:
    frmMain.MIDIOutput1.Message = CONTROLLER_CHANGE + MidiChannelOut
    frmMain.MIDIOutput1.Data1 = PAN
    frmMain.MIDIOutput1.Data2 = MyX
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Velocity " & -(MyY - 128) & ", " & "Pan " & MyX
End Sub

Public Sub AllOff()
Dim X, OriginalChannel As Integer

For X = 0 To 127
    For MidiChannelOut = 0 To 15
        frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
        frmMain.MIDIOutput1.Data2 = 0
        frmMain.MIDIOutput1.Data1 = X
        frmMain.MIDIOutput1.Time = 0
        frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    Next MidiChannelOut
Next X

MidiChannelOut = OriginalChannel
End Sub


Sub MIDIInOpen()
    Dim wRtn As Integer
    
    If frmMain.MIDIInput1.State >= MIDISTATE_OPEN Then
        ' Close midiin port
        frmMain.MIDIInput1.Action = MIDIIN_CLOSE
    End If

    
    ' Get selected device id
    frmMain.MIDIInput1.DeviceID = MIDISetupForm.ComboMidiIn.ListIndex
    
    ' Open and display handle
    frmMain.MIDIInput1.Action = MIDIIN_OPEN

    ' Start midi input
    frmMain.MIDIInput1.Action = MIDIIN_START
    
    note = 0
End Sub

Sub MIDIOutOpen()

    If frmMain.MIDIOutput1.State >= MIDISTATE_OPEN Or frmMain.MIDIOutput1.DeviceID = -1 Then
        ' Close
        frmMain.MIDIOutput1.Action = MIDIOUT_CLOSE
    End If
    

    ' Open selected device
    frmMain.MIDIOutput1.DeviceID = MIDISetupForm.ComboMidiOut.ListIndex - 1
    frmMain.MIDIOutput1.Action = MIDIOUT_OPEN
    
    '
    ' Return buttons and variables to preplay state
    '
End Sub

Public Sub MouseMode1()
    frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    frmMain.MIDIOutput1.Data2 = MyX
    frmMain.MIDIOutput1.Data1 = -(MyY - 128)
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Pitch " & -(MyY - 128) & ", " & "Vel " & MyX
End Sub


Public Sub MouseMode2()
    frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    frmMain.MIDIOutput1.Data2 = frmMain.VelText(PerfIndex).Text
    frmMain.MIDIOutput1.Data1 = -(MyY - 128)
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    'pan:
    frmMain.MIDIOutput1.Message = CONTROLLER_CHANGE + MidiChannelOut
    frmMain.MIDIOutput1.Data1 = PAN
    frmMain.MIDIOutput1.Data2 = MyX
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Pitch " & -(MyY - 128) & ", " & "Pan " & MyX
End Sub


Public Sub MouseMode3()
    MidiChannelOut = Int(MyX / 8) 'half the usual amount for channels
    
    frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    frmMain.MIDIOutput1.Data2 = frmMain.VelText(PerfIndex).Text
    frmMain.MIDIOutput1.Data1 = -(MyY - 128)
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Pitch " & MyY & ", " & "Channel " & MidiChannelOut
End Sub


Public Sub MouseMode4()
' pitch/volume
    If MidiChannelOut > 64 Then MidiChannelOut = 0
    MidiVolume(MidiChannelOut) = MyX
    
    frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    frmMain.MIDIOutput1.Data2 = frmMain.VelText(PerfIndex).Text
    frmMain.MIDIOutput1.Data1 = -(MyY - 128)
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Pitch " & -(MyY - 128) & ", " & "Volume " & MyX
End Sub


Public Sub MouseMode50()
 ' programme/pitch
    frmMain.MIDIOutput1.Message = NOTE_ON + MidiChannelOut
    frmMain.MIDIOutput1.Data2 = 120
    frmMain.MIDIOutput1.Data1 = -(MyX - 128)
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    ':
    frmMain.MIDIOutput1.Message = PROGRAM_CHANGE + MidiChannelOut
    frmMain.MIDIOutput1.Data1 = MyY
    frmMain.MIDIOutput1.Data2 = 0
    frmMain.MIDIOutput1.Time = 0
    frmMain.MIDIOutput1.Action = MIDIOUT_SEND
    '
    frmMain.InfoLabel(PerfIndex).Caption = "Pitch " & -(MyX - 128) & ", " & "Prog " & MyY
End Sub


Public Sub MouseMode51()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
Public Sub MouseMode52()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
Public Sub MouseMode53()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
Public Sub MouseMode54()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
Public Sub MouseMode55()
    frmMain.InfoLabel(PerfIndex).Caption = "Not yet available"
End Sub
